package dk.hlyh.ciplugins.projecthealth;

import hudson.Extension;
import hudson.model.AbstractProject;
import hudson.model.Action;
import hudson.model.TransientProjectActionFactory;

import java.util.ArrayList;
import java.util.Collection;

/**
 * Extends project actions for all jobs.
 *
 * @author Henrik Lynggaard Hansen <henrik@hlyh.dk>
 */
@Extension
public class ProjectHealthActionFactory extends TransientProjectActionFactory {


    /**
     * {@inheritDoc}
     */
    @Override
    public Collection<? extends Action> createFor(@SuppressWarnings("unchecked") AbstractProject target) {
        ArrayList<Action> actions = new ArrayList<Action>();                
        ProjectHealthProjectAction newAction = new ProjectHealthProjectAction(target);
        
        actions.add(newAction);
        return actions;
    }
}
