/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dk.hlyh.ciplugins.projecthealth;

import hudson.model.Run;
import hudson.util.RunList;
import java.util.List;

/**
 *
 * @author henrik
 */
public class ProjectHealthState {
    
    public enum OptionValue{
        All,
        Recent,
        Period,
    }    
    
    // form input
    private OptionValue optionParameter;
    private int recentBuildsParameter;
    private long firstBuildParameter;
    private long lastBuildParameter;
    private boolean groupOnErrorMessageParameter;
    
    
    // builds 
    private RunList<?> allBuilds;
    private List<Run<?, ?>> selectedBuilds;
    private Run<?, ?> firstSelectedBuild;
    private Run<?, ?> lastSelectedBuild;
    private int totalBuilds;
    private int failedBuilds;
    private int goodBuilds;
    
    // test cases
    private int totalFailures;
    private List<TestFailure> failures;
    
    // graphs
    private String overviewPie;
    private String failuresPie;

    public RunList<?> getAllBuilds() {
        return allBuilds;
    }

    public void setAllBuilds(RunList<?> allBuilds) {
        this.allBuilds = allBuilds;
    }

    public int getFailedBuilds() {
        return failedBuilds;
    }

    public void setFailedBuilds(int failedBuilds) {
        this.failedBuilds = failedBuilds;
    }

    public String getFailuresPie() {
        return failuresPie;
    }

    public void setFailuresPie(String failuresPie) {
        this.failuresPie = failuresPie;
    }

    public List<TestFailure> getFailures() {
        return failures;
    }

    public void setFailures(List<TestFailure> failures) {
        this.failures = failures;
    }

    public long getFirstBuildParameter() {
        return firstBuildParameter;
    }

    public void setFirstBuildParameter(long firstBuildParameter) {
        this.firstBuildParameter = firstBuildParameter;
    }

    public Run<?, ?> getFirstSelectedBuild() {
        return firstSelectedBuild;
    }

    public void setFirstSelectedBuild(Run<?, ?> firstSelectedBuild) {
        this.firstSelectedBuild = firstSelectedBuild;
    }

    public int getGoodBuilds() {
        return goodBuilds;
    }

    public void setGoodBuilds(int goodBuilds) {
        this.goodBuilds = goodBuilds;
    }

    public boolean isGroupOnErrorMessageParameter() {
        return groupOnErrorMessageParameter;
    }

    public void setGroupOnErrorMessageParameter(boolean groupOnErrorMessageParameter) {
        this.groupOnErrorMessageParameter = groupOnErrorMessageParameter;
    }

    public long getLastBuildParameter() {
        return lastBuildParameter;
    }

    public void setLastBuildParameter(long lastBuildParameter) {
        this.lastBuildParameter = lastBuildParameter;
    }

    public Run<?, ?> getLastSelectedBuild() {
        return lastSelectedBuild;
    }

    public void setLastSelectedBuild(Run<?, ?> lastSelectedBuild) {
        this.lastSelectedBuild = lastSelectedBuild;
    }

    public OptionValue getOptionParameter() {
        return optionParameter;
    }

    public void setOptionParameter(OptionValue optionParameter) {
        this.optionParameter = optionParameter;
    }

    public String getOverviewPie() {
        return overviewPie;
    }

    public void setOverviewPie(String overviewPie) {
        this.overviewPie = overviewPie;
    }

    public int getRecentBuildsParameter() {
        return recentBuildsParameter;
    }

    public void setRecentBuildsParameter(int recentBuildsParameter) {
        this.recentBuildsParameter = recentBuildsParameter;
    }

    public List<Run<?, ?>> getSelectedBuilds() {
        return selectedBuilds;
    }

    public void setSelectedBuilds(List<Run<?, ?>> selectedBuilds) {
        this.selectedBuilds = selectedBuilds;
    }

    public int getTotalFailures() {
        return totalFailures;
    }

    public void setTotalFailures(int totalFailures) {
        this.totalFailures = totalFailures;
    }

    public int getTotalBuilds() {
        return totalBuilds;
    }

    public void setTotalBuilds(int totalBuilds) {
        this.totalBuilds = totalBuilds;
    }
    
    public boolean getOptionAllChecked() {
        return optionParameter == OptionValue.All;
    }

    public boolean getOptionRecentChecked() {
        return optionParameter == OptionValue.Recent;
    }
    public boolean getOptionPeriodChecked() {
        return optionParameter == OptionValue.Period;
    }    
    
}
